unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, RcsStrings, StdCtrls, Menus, Math, Code, CheckLst, ClipBrd, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    MainMenu1: TMainMenu;
    Code1: TMenuItem;
    PIC1: TMenuItem;
    ListBox1: TListBox;
    Help1: TMenuItem;
    Reset1: TMenuItem;
    ClearAll1: TMenuItem;
    ClearConfigbits1: TMenuItem;
    ClearRegisterSettings1: TMenuItem;
    ReloadAll1: TMenuItem;
    Calculate1: TMenuItem;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    procedure FormShow(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    //procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Code1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure PIC1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure ClearAll1Click(Sender: TObject);
    procedure ClearConfigbits1Click(Sender: TObject);
    procedure ClearRegisterSettings1Click(Sender: TObject);
    procedure ReloadAll1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Calculate1Click(Sender: TObject);
  private
    { Private declarations }
    procedure Read_Lines(Pic: string);
    procedure Clear_Line(I: word);
    procedure Red_Line(I: word);
    procedure Clear_Lines;
    procedure Clear_Line_Register(I: word);
    procedure Red_Line_Register(I: word);
    procedure Clear_Lines_Register;
    procedure Follow_Lines;
    procedure Follow_Not_Lines;
    procedure Clear_Exclusive_Groups(Group: word);
    procedure Clear_Group(Group: word);
    function Within(X, Y, X1, Y1, X2, Y2: word): boolean;
    procedure Get_Config_bits(ProcName: string);
    procedure Calc_Value(FieldName: string; Value: DWord);
    procedure Select_Processor(ProcName: string);
    procedure Load_PIcs;
    procedure EditKeypress(Sender: TObject; var Key: Char);
    procedure Select_First_Lines;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses SimpleIniFile, RcsDirectories, Help, RcsEval;

{$R *.dfm}

type TLine_ = record
    Name: string;
    Group, Id: word;
    X1, Y1, X2, Y2: word;
    Excl, Incl: integer;
    Value: Dword;
    Calc: Real;
  end;

type TLineRegister_ = record
    Name: string;
    Group, Id: word;
    X1, Y1, X2, Y2: word;
    Excl, Incl: integer;
    Value: Dword;
    Calc: Real;
    Comments: string;
  end;

type TFollow_ = record
    X1, Y1, X2, Y2: word;
    Groups: array of word;
  end;

type TExcl_Groups = record
    Groups: array of word;
  end;

type TPic_Type = record
    Wanted, ToUse: string;
  end;

var
  Lines_: array of TLine_;
  Lines_Register: array of TLineRegister_;
  Lines_Red: array of boolean;
  Lines_Red_Register: array of boolean;
  Follows_, Follows_Not_: array of TFollow_;
  Excl_Groups_: array of TExcl_Groups;
  Pic_Types: array of TPic_Type;

type
  TSetting =
    record
    WReq: DWord;
    WValue: DWord;
    SDesc: ansistring;
  end;

  TField =
    record
    SKey, SDesc: ansistring;
    WMask: DWord;
    Settings: array of TSetting;
  end;

  TConfigWord =
    record
    SKey: ansistring;
    WAddr: DWord;
    Fields: array of TField;
  end;

  TState = (Waiting, CfgFound, CfgbitsX, FieldX, SettingX, CfgDone);

  TRegVal = record
    RegName: string;
    Value: Dword;
    Calc: real;
    Comments: string;
    Changed: boolean;
  end;

  TCalcVal = record
    FieldName: string;
    Calc: real;
  end;

  TFormula = record
    Destination: string;
    X, Y: word;
    Formula: string;
  end;

var
  ProcessorName, DefsDirectory: ansistring;
  IniFile: TSimpleIniFile;
  ActualDefPaths: array[0..8] of ansistring;
  ConfigBits: array of TConfigWord; // the possible settings from the MLK file

  LoadingState: TState;
  CfgBitsIndex, FieldIndex, SettingsIndex: word; // indexes into the ConfigBits array

  FieldNames_, RegisterNames_: TStringList;
  RegisterValues: array of TRegVal;
  CalcValues: array of TCalcVal;

  Error: boolean;
  Eval: TSimpleEval;
  DoCalculate: boolean;

const LAST_EDIT = 30;
var
  Edits: array[0..LAST_EDIT] of TEdit;
  NrOfEdits: word;
  Formulas: array of TFormula;

const
  ProjectFileExtensions:
  array[0..8] of ansistring =
    (
    '.mpppi', // mP PIC
    '.mppds', // mP dsPIC&PIC24
    '.mpp32', // mP PIC32

    '.mbppi', // mB PIC
    '.mbpds', // mB dsPIC&PIC24
    '.mbp32', // mB PIC32

    '.mcppi', // mC PIC
    '.mcpds', // mC dsPIC&PIC24
    '.mcp32' // mC PIC32
    );

  Win7DefPaths:
  array[0..8] of ansistring =
    (
    'C:\Users\Public\Documents\MikroElektronika\mikroPascal PRO for PIC\Defs',
    'C:\Users\Public\Documents\MikroElektronika\mikroPascal PRO for dsPIC\Defs',
    'C:\Users\Public\Documents\MikroElektronika\mikroPascal PRO for PIC32\Defs',

    'C:\Users\Public\Documents\MikroElektronika\mikroBasic PRO for PIC\Defs',
    'C:\Users\Public\Documents\MikroElektronika\mikroBasic PRO for dsPIC\Defs',
    'C:\Users\Public\Documents\MikroElektronika\mikroBasic PRO for PIC32\Defs',

    'C:\Users\Public\Documents\MikroElektronika\mikroC PRO for PIC\Defs',
    'C:\Users\Public\Documents\MikroElektronika\mikroC PRO for dsPIC\Defs',
    'C:\Users\Public\Documents\MikroElektronika\mikroC PRO for PIC32\Defs'
    );

  XpDefPaths: array[0..8] of ansistring =
  (
    'C:\Program Files\MikroElektronika\mikroPascal PRO for PIC\Defs',
    'C:\Program Files\MikroElektronika\mikroPascal PRO for PIC\Defs',
    'C:\Program Files\MikroElektronika\mikroPascal PRO for PIC\Defs',

    'C:\Program Files\MikroElektronika\mikroPascal PRO for PIC\Defs',
    'C:\Program Files\MikroElektronika\mikroPascal PRO for PIC\Defs',
    'C:\Program Files\MikroElektronika\mikroPascal PRO for PIC\Defs',

    'C:\Program Files\MikroElektronika\mikroPascal PRO for PIC\Defs',
    'C:\Program Files\MikroElektronika\mikroPascal PRO for PIC\Defs',
    'C:\Program Files\MikroElektronika\mikroPascal PRO for PIC\Defs'
    );

procedure RemoveJunk(var S: ansistring);
var
  P1, P2: word;
begin
  P1 := pos('<', S);
  P2 := pos('>', S);
  while (P1 > 0) and (P2 > 0) do
  begin
    Delete(S, P1, (P2 - P1 + 1));
    P1 := pos('<', S);
    P2 := pos('>', S);
  end;
  S := trim(S);
end;

function Keyword(Key, S: ansistring): boolean;
begin
  Result := false;
  Key := '<' + Key + '>';
  if pos(uppercase(Key), uppercase(S)) > 0 then Result := true;
end;

function KeywordX(Key, S: ansistring): boolean;
var
  P1, P2: word;
begin
  Result := false;
  Key := '<' + Key;
  P1 := pos(uppercase(Key), uppercase(S));
  P2 := pos('>', S);
  if (P1 > 0) and (P2 > (P1 + length(Key))) then Result := true;
end;

function NormalisedValue(Value, Mask: DWord): string;
var Shft: integer;
  Bits: byte;
  Power: Dword;
  TmP: string;
begin
  Shft := 0;
  Bits := 0;

  while (Mask > 0) do
  begin
    while ((Mask and 1) = 0) and (Mask > 0) do
    begin
      inc(Shft);
      Mask := Mask shr 1;
    end;

    while ((Mask and 1) = 1) and (Mask > 0) do
    begin
      inc(Bits);
      Mask := Mask shr 1;
    end;
  end;

  Value := Value shr Shft;

  Result := '';
  Power := 32768;
  Tmp := '';
  while (Power > 0) do
  begin
    if ((Value and Power) > 0) then
      Tmp := Tmp + '1'
    else
      Tmp := Tmp + '0';

    Power := Power div 2;
  end;
  Result := Tmp;

  while (Length(Result) > 0) and (Result[1] = '0') do delete(Result, 1, 1);
  while length(Result) < Bits do Result := '0' + result;

  Result := ' (= "' + result + '")';
end;

procedure TForm1.Read_Lines(Pic: string);
var TmpStr, Comments: string;
  F: TextFile;
  Len_, Len_Groups, Len_Excl: word;
  Tmp: TStringList;
  TmpGroups: TStringList;
  I, J, K, P: word;
  ErrCode: integer;
  TmpReal: real;
  TmpS1, TmpS2: string;
begin

  Tmp := TStringList.Create;
  TmpGroups := TStringList.Create;

  SetLength(Lines_, 0);
  SetLength(Lines_Register, 0);
  SetLength(Follows_, 0);
  SetLength(Follows_Not_, 0);
  SetLength(Excl_Groups_, 0);

  AssignFile(F, 'Oscillator_' + Pic + '_lines.txt');
  Reset(F);

  FieldNames_.Clear;
  RegisterNames_.Clear;
  SetLength(RegisterValues, 0);
  SetLength(CalcValues, 0);
  SetLength(Formulas, 0);
  NrOfEdits := 0;

  while not Eof(F) do
  begin
    ReadLn(F, TmpStr);

    Comments := '';
    P := pos('//', TmpStr);
    if (P > 0) then
    begin
      Comments := Copy(TmpStr, P, 255);
      TmpStr := Copy(TmpStr, 1, P - 1);
    end;
    TmpStr := trim(TmpStr);
    Comments := trim(Comments);

    if (TmpStr > '') then
    begin
      StringToTStrings(TmpStr, Tmp, ','); // split on comma

      for J := 0 to Tmp.Count - 1 do Tmp[J] := trim(Tmp[J]);

      Tmp[0] := uppercase(Tmp[0]); // get name

      if pos('<', Tmp[0]) = 0 then // no register line
      begin

        if (Tmp[0] = 'FOLLOW') then
        begin
          Len_ := length(Follows_);
          SetLength(Follows_, Len_ + 1);

          Follows_[Len_].X1 := StrToInt(Tmp[1]);
          Follows_[Len_].Y1 := StrToInt(Tmp[2]);
          Follows_[Len_].X2 := StrToInt(Tmp[3]);
          Follows_[Len_].Y2 := StrToInt(Tmp[4]);

          TmpGroups.Clear;
          Tmp[5] := trim(Tmp[5]);

          StringToTStrings(Tmp[5], TmpGroups, ' '); // split on space
          if (TmpGroups.Count > 0) then
          begin
            for J := 0 to TmpGroups.Count - 1 do
            begin
              TmpGroups[J] := trim(TmpGroups[J]);
              if TmpGroups[J] > '' then
              begin
                Len_Groups := length(Follows_[Len_].Groups);
                setlength(Follows_[Len_].Groups, Len_Groups + 1);
                Follows_[Len_].Groups[Len_Groups] := StrToInt(TmpGroups[J]);
              end;
            end;
          end;
        end else

          if (Tmp[0] = 'FOLLOW_NOT') then
        begin
          Len_ := length(Follows_Not_);
          SetLength(Follows_Not_, Len_ + 1);

          Follows_Not_[Len_].X1 := StrToInt(Tmp[1]);
          Follows_Not_[Len_].Y1 := StrToInt(Tmp[2]);
          Follows_Not_[Len_].X2 := StrToInt(Tmp[3]);
          Follows_Not_[Len_].Y2 := StrToInt(Tmp[4]);

          TmpGroups.Clear;
          Tmp[5] := trim(Tmp[5]);

          StringToTStrings(Tmp[5], TmpGroups, ' '); // split on space
          if (TmpGroups.Count > 0) then
          begin
            for J := 0 to TmpGroups.Count - 1 do
            begin
              TmpGroups[J] := trim(TmpGroups[J]);
              if TmpGroups[J] > '' then
              begin
                Len_Groups := length(Follows_Not_[Len_].Groups);
                setlength(Follows_Not_[Len_].Groups, Len_Groups + 1);
                Follows_Not_[Len_].Groups[Len_Groups] := StrToInt(TmpGroups[J]);
              end;
            end;
          end;
        end else

          if (Tmp[0] = 'EXCL') then
        begin
          Len_ := length(Excl_Groups_);
          setLength(Excl_groups_, Len_ + 1);

          for K := 1 to Tmp.Count - 1 do
          begin
            Tmp[K] := trim(Tmp[K]);
            if tmp[K] > '' then
            begin
              Len_Excl := length(Excl_Groups_[Len_].Groups);
              setlength(Excl_Groups_[Len_].Groups, Len_Excl + 1);
              Excl_Groups_[Len_].Groups[Len_Excl] := strtoint(tmp[K]);
            end;
          end;
        end else

          if (Tmp[0] = 'SHOWVAL') then
        begin
          // store the formula
          Len_ := length(Formulas);
          SetLength(Formulas, Len_ + 1);
          Formulas[Len_].X := strtoint(Tmp[1]);
          Formulas[Len_].Y := strtoint(Tmp[2]);

          SplitString(Tmp[3], '=', TmpS1, TmpS2);
          TmpS1 := trim(TmpS1); // destination
          TmpS2 := trim(TmpS2); // first part of formula

          Formulas[Len_].Destination := TmpS1;

          if Tmp.Count >= 4 then // formula present
          begin
            if Tmp.Count > 4 // formula is in pieces, make whole again
              then for I := 4 to (Tmp.Count - 1) do TmpS2 := TmpS2 + ',' + Tmp[I];
            Formulas[Len_].Formula := TmpS2;
          end
          else Formulas[Len_].Formula := '';

          // display the edit fields
          Edits[NrOfEdits].Left := strtoInt(Tmp[1]);
          Edits[NrOfEdits].Top := strtoint(Tmp[2]);

          if Formulas[Len_].Formula = ''
            then
          begin
            Edits[NrOfEdits].ReadOnly := false;
            Edits[NrOfEdits].TabStop := true;
            Edits[NrOfEdits].Color := clYellow;
            Edits[NrOfEdits].BorderStyle := bsSingle;
            //Edits[NrOfEdits].Font.Color := clBlack;
            Edits[NrOfEdits].Text := '4 Mhz';
          end
          else
          begin
            Edits[NrOfEdits].ReadOnly := true;
            Edits[NrOfEdits].TabStop := false;
            Edits[NrOfEdits].Color := clWindow;
            Edits[NrOfEdits].BorderStyle := bsNone;
            //Edits[NrOfEdits].Font.Color := clRed;
          end;

          Edits[NrOfEdits].OnKeyPress := EditKeypress;
          Edits[NrOfEdits].Visible := true;

          inc(NrOfEdits);
        end else

        begin // simple "Line"
          Len_ := length(Lines_);
          Setlength(Lines_, Len_ + 1);

          Lines_[Len_].Name := Tmp[0];
          Lines_[Len_].Group := StrToInt(Tmp[1]);
          Lines_[Len_].Id := StrToInt(Tmp[2]);
          Lines_[Len_].X1 := StrToInt(Tmp[3]);
          Lines_[Len_].Y1 := StrToInt(Tmp[4]);
          Lines_[Len_].X2 := StrToInt(Tmp[5]);
          Lines_[Len_].Y2 := StrToInt(Tmp[6]);
          Lines_[Len_].Excl := StrToInt(Tmp[7]);
          Lines_[Len_].Incl := StrToInt(Tmp[8]);
          Lines_[Len_].Value := StrToInt(Tmp[9]);

          Lines_[Len_].Calc := 1.0; // default value

          if Tmp.Count > 10
            then TmpS1 := Tmp[10] // get the formula value
          else TmpS1 := Tmp[9];   // use the diagram value as formula value

          Val(TmpS1, TmpReal, ErrCode);
          if ErrCode = 0 then
          Lines_[Len_].Calc := TmpReal;

          TmpReal := Lines_[Len_].Calc; // get actual value back

          setlength(Lines_Red, length(Lines_));
          Lines_Red[Len_] := false;

          if FieldNames_.IndexOf(Tmp[0]) = -1 then // new fieldname
          begin
            FieldNames_.Add(Tmp[0]);
            SetLength(CalcValues, FieldNames_.Count);
            CalcValues[FieldNames_.Count - 1].FieldName := Tmp[0];
            CalcValues[FieldNames_.Count - 1].Calc := TmpReal; // default value
          end;

        end;

      end else
      begin // register line
        Len_ := length(Lines_Register);
        Setlength(Lines_Register, Len_ + 1);

        Lines_Register[Len_].Name := Tmp[0];
        Lines_Register[Len_].Group := StrToInt(Tmp[1]);
        Lines_Register[Len_].Id := StrToInt(Tmp[2]);
        Lines_Register[Len_].X1 := StrToInt(Tmp[3]);
        Lines_Register[Len_].Y1 := StrToInt(Tmp[4]);
        Lines_Register[Len_].X2 := StrToInt(Tmp[5]);
        Lines_Register[Len_].Y2 := StrToInt(Tmp[6]);
        Lines_Register[Len_].Excl := StrToInt(Tmp[7]);
        Lines_Register[Len_].Incl := StrToInt(Tmp[8]);
        Lines_Register[Len_].Value := StrToInt(Tmp[9]);
        LInes_Register[Len_].Comments := Comments;

        Lines_Register[Len_].Calc := 1.0; // default value
        if tmp.Count > 10
          then TmpS1 := tmp[10]
        else TmpS1 := Tmp[9];

        Val(TmpS1, TmpReal, ErrCode);
        if ErrCode = 0 then
        Lines_Register[Len_].Calc := TmpReal;
        TmpReal := Lines_Register[Len_].Calc;

        setlength(Lines_Red_Register, length(Lines_Register));
        Lines_Red_Register[Len_] := false;

        if RegisterNames_.IndexOf(Tmp[0]) = -1 then // new register name
        begin
          // add to list of register names
          RegisterNames_.Add(Tmp[0]);

          // add to list of register values
          Len_ := length(RegisterValues);
          setlength(RegisterValues, Len_ + 1);
          RegisterValues[Len_].RegName := Tmp[0];
          RegisterValues[Len_].Value := 0;
          RegisterValues[Len_].Calc := TmpReal;
          RegisterValues[Len_].Comments := '';
          RegisterValues[Len_].Changed := false;

        end;
      end;

    end;
  end;
  Tmp.Free;
  TmpGroups.Free;
  CloseFile(F);

end;

procedure TForm1.Clear_Line(I: word);
begin
  Image1.Canvas.TryLock;
  Image1.Canvas.Pen.Color := clBlue;
  Image1.Canvas.Pen.Width := 2;
  Image1.Canvas.Pen.Mode  := pmCopy;
  Image1.Canvas.MoveTo(Lines_[I].X1, Lines_[I].Y1);
  Image1.Canvas.LineTo(Lines_[I].X2, Lines_[I].Y2);
  Image1.Canvas.Unlock;

  Lines_Red[I] := false;
end;

procedure TForm1.Red_Line(I: word);
begin
  Image1.Canvas.TryLock;
  Image1.Canvas.Pen.Color := clRed;
  Image1.Canvas.Pen.Width := 2;
  Image1.Canvas.Pen.Mode := pmCopy;
  Image1.Canvas.MoveTo(Lines_[I].X1, Lines_[I].Y1);
  Image1.Canvas.LineTo(Lines_[I].X2, Lines_[I].Y2);
  Image1.Canvas.Unlock;

  Lines_Red[I] := true;
end;

procedure TForm1.Clear_Lines;
var i: word;
begin
  if Length(Lines_) > 0 then
  begin
    for I := 0 to high(Lines_) do Clear_Line(I);
  end;
end;

procedure TForm1.Clear_Line_Register(I: word);
begin
  Image1.Canvas.TryLock;
  Image1.Canvas.Pen.Color := clLime;
  Image1.Canvas.Pen.Width := 2;
  Image1.Canvas.Pen.Mode := pmCopy;
  Image1.Canvas.MoveTo(Lines_Register[I].X1, Lines_Register[I].Y1);
  Image1.Canvas.LineTo(Lines_Register[I].X2, Lines_Register[I].Y2);
  Image1.Canvas.Unlock;

  Lines_Red_Register[I] := false;
end;

procedure TForm1.Red_Line_Register(I: word);
begin
  Image1.Canvas.TryLock;
  Image1.Canvas.Pen.Color := clRed;
  Image1.Canvas.Pen.Width := 2;
  Image1.Canvas.Pen.Mode := pmCopy;
  Image1.Canvas.MoveTo(Lines_Register[I].X1, Lines_Register[I].Y1);
  Image1.Canvas.LineTo(Lines_Register[I].X2, Lines_Register[I].Y2);
  Image1.Canvas.Unlock;

  Lines_Red_Register[I] := true;
end;

procedure TForm1.Clear_Lines_Register;
var i: word;
begin
  if Length(Lines_Register) > 0 then
  begin
    for I := 0 to high(Lines_Register) do Clear_Line_Register(I);
  end;
end;

function TForm1.Within(X, Y, X1, Y1, X2, Y2: word): boolean;
begin
  X1 := X1 - 3;
  Y1 := Y1 - 3;
  X2 := X2 + 3;
  Y2 := Y2 + 3;

  Result := (X >= X1) and (Y >= Y1) and (X <= X2) and (Y <= Y2);
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var XStr, YStr: string;
begin
  XStr := IntToStr(X);
  YStr := IntToStr(Y);
  Label41.Caption := 'X: ' + XStr + ', Y: ' + YStr;
end;

procedure TForm1.Calc_Value(FieldName: string; Value: DWord);
var CfgBitsIndex, FieldIndex, SettingsIndex: word;
  ValueDescription, FieldDescription: string;
  I: word;
begin
  for CfgBitsIndex := 0 to high(ConfigBits) do
  begin
    for FieldIndex := 0 to high(ConfigBits[CfgBitsIndex].Fields) do
    begin
      if ConfigBits[CfgBitsIndex].Fields[FieldIndex].SKey = FieldName then
      begin

        for SettingsIndex := 0 to high(ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings) do
        begin
          if ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings[SettingsIndex].WValue = Value then
          begin

            FieldDescription := ConfigBits[CfgBitsIndex].Fields[FieldIndex].SDesc;
            ValueDescription := ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings[SettingsIndex].SDesc;

            // find the appropriate fieldname
            for I := 0 to FieldNames_.Count - 1 do
            begin
              if FieldName = FieldNames_[I] then
              begin
                case I of
                  0: Label2.Caption := ValueDescription;
                  1: Label4.Caption := ValueDescription;
                  2: Label6.Caption := ValueDescription;
                  3: Label8.Caption := ValueDescription;
                  4: Label10.Caption := ValueDescription;
                  5: Label12.Caption := ValueDescription;
                  6: Label14.Caption := ValueDescription;
                  7: Label16.Caption := ValueDescription;
                  8: Label18.Caption := ValueDescription;
                  9: Label20.Caption := ValueDescription;
                  10: Label22.Caption := ValueDescription;
                  11: Label24.Caption := ValueDescription;
                  12: Label26.Caption := ValueDescription;
                  13: Label28.Caption := ValueDescription;
                  14: Label30.Caption := ValueDescription;
                  15: Label32.Caption := ValueDescription;
                  16: Label34.Caption := ValueDescription;
                  17: Label36.Caption := ValueDescription;
                  18: Label38.Caption := ValueDescription;
                  19: Label40.Caption := ValueDescription;
                end;
              end;
            end;
            exit;
          end;
        end;
      end;
    end;
  end;
end;

procedure TForm1.Follow_Lines;
var I, J, K: word;
  On_: boolean;
begin

  if length(Follows_) > 0 then
  begin
    for I := 0 to length(Follows_) - 1 do
    begin
      On_ := false;

      // check the configuration lines
      if length(Lines_) > 0 then
      begin
        for J := 0 to length(Lines_) - 1 do
        begin
          for K := 0 to length(Follows_[I].Groups) - 1 do
          begin

            if Follows_[I].Groups[K] = Lines_[J].Group then
            begin
              if Lines_Red[J] then On_ := true;
            end;

          end;
        end;
      end;

      // check the register lines
      if length(Lines_Register) > 0 then
      begin
        for J := 0 to length(Lines_Register) - 1 do
        begin
          for K := 0 to length(Follows_[I].Groups) - 1 do
          begin

            if Follows_[I].Groups[K] = Lines_Register[J].Group then
            begin
              if Lines_Red_Register[J] then On_ := true;
            end;

          end;
        end;
      end;

      if On_ then
      begin
        Image1.Canvas.TryLock;
        Image1.Canvas.Pen.Color := clRed;
        Image1.Canvas.Pen.Width := 1;
        Image1.Canvas.Pen.Mode := pmCopy;
        Image1.Canvas.MoveTo(Follows_[I].X1, Follows_[I].Y1);
        Image1.Canvas.LineTo(Follows_[I].X2, Follows_[I].Y2);
        Image1.Canvas.Unlock;
      end else
      begin
        Image1.Canvas.TryLock;
        Image1.Canvas.Pen.Color := clBlack;
        Image1.Canvas.Pen.Width := 1;
        Image1.Canvas.Pen.Mode := pmCopy;
        Image1.Canvas.MoveTo(Follows_[I].X1, Follows_[I].Y1);
        Image1.Canvas.LineTo(Follows_[I].X2, Follows_[I].Y2);
        Image1.Canvas.Unlock;
      end;

    end;
  end;
end;

procedure TForm1.Follow_Not_Lines;
var I, J, K: word;
  On_: boolean;
begin

  if length(Follows_Not_) > 0 then
  begin
    for I := 0 to length(Follows_Not_) - 1 do
    begin
      On_ := true;

      // check the configuration lines
      if length(Lines_) > 0 then
      begin
        for J := 0 to length(Lines_) - 1 do
        begin
          for K := 0 to length(Follows_Not_[I].Groups) - 1 do
          begin

            if Follows_Not_[I].Groups[K] = Lines_[J].Group then
            begin
              if Lines_Red[J] then On_ := false;
            end;

          end;
        end;
      end;

      // check the register lines
      if length(Lines_Register) > 0 then
      begin
        for J := 0 to length(Lines_Register) - 1 do
        begin
          for K := 0 to length(Follows_Not_[I].Groups) - 1 do
          begin

            if Follows_Not_[I].Groups[K] = Lines_Register[J].Group then
            begin
              if Lines_Red_Register[J] then On_ := false;
            end;

          end;
        end;
      end;

      if On_ then
      begin
        Image1.Canvas.TryLock;
        Image1.Canvas.Pen.Color := clRed;
        Image1.Canvas.Pen.Width := 1;
        Image1.Canvas.Pen.Mode := pmCopy;
        Image1.Canvas.MoveTo(Follows_Not_[I].X1, Follows_Not_[I].Y1);
        Image1.Canvas.LineTo(Follows_Not_[I].X2, Follows_Not_[I].Y2);
        Image1.Canvas.UnLock;
      end else
      begin
        Image1.Canvas.TryLock;
        Image1.Canvas.Pen.Color := clBlack;
        Image1.Canvas.Pen.Width := 1;
        Image1.Canvas.Pen.Mode := pmCopy;
        Image1.Canvas.MoveTo(Follows_Not_[I].X1, Follows_Not_[I].Y1);
        Image1.Canvas.LineTo(Follows_Not_[I].X2, Follows_Not_[I].Y2);
        Image1.Canvas.Unlock;
      end;

    end;
  end;
end;

procedure TForm1.Clear_Group(Group: word);
var I: word;
begin
  if length(Lines_) > 0 then
  begin
    for I := 0 to length(Lines_) - 1 do
    begin
      if Lines_[I].Group = Group then
      begin // line to be cleared
        Clear_Line(I);
      end;
    end;
  end;

  if length(Lines_Register) > 0 then
  begin
    for I := 0 to length(Lines_Register) - 1 do
    begin
      if Lines_Register[I].Group = Group then
      begin // line to be cleared
        Clear_Line_Register(I);
      end
    end;
  end;
end;

procedure TForm1.Clear_Exclusive_Groups(Group: word);
var I, J: word;
  Present: boolean;
begin
  if length(Excl_Groups_) > 0 then
  begin

    for I := 0 to length(Excl_Groups_) - 1 do // check all exclusion lines
    begin
      Present := false;

      // check all entries in a line to see if Group is present
      if length(Excl_Groups_[I].Groups) > 0 then
      begin
        for J := 0 to length(Excl_Groups_[I].Groups) - 1 do
        begin
          if Excl_Groups_[I].Groups[J] = Group then // group is present in the excl group line
          begin
            Present := true;
            break;
          end;
        end;
      end;

      if Present then // the excl group line contains the group
      begin
        for J := 0 to length(Excl_Groups_[I].Groups) - 1 do
        begin
          if Excl_Groups_[I].Groups[J] <> Group
            then Clear_Group(Excl_Groups_[I].Groups[J]);
        end;
      end;
    end;
  end;

end;

var X1, Y1, X2, Y2: word;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var I, J, K: word;
  Found: boolean;
  TmpStr: string;
begin

  if Button = mbLeft then
  begin
    Found := false;

    if (Length(Lines_) > 0) then
    begin
      for I := low(Lines_) to high(Lines_) do
      begin
        if Within(X, Y, Lines_[I].X1, Lines_[I].Y1, Lines_[I].X2, Lines_[I].Y2)
          then
        begin
          Found := true;

          begin
            Red_Line(I);

            Calc_Value(Lines_[I].Name, Lines_[I].Value); // show result

            // save the calculation value
            for K := 0 to length(CalcValues) - 1 do
            begin
              if CalcValues[K].FieldName = Lines_[I].Name
                then CalcValues[K].Calc := Lines_[I].Calc;
            end;

          // make lines red in the inclusive group
            for J := low(Lines_) to high(Lines_) do
            begin
              if (Lines_[J].Incl <> -1)
                and (Lines_[I].Incl <> -1)
                and (Lines_[J].Incl = Lines_[I].Incl)
                then Red_Line(J);
            end;

          // clear lines in the exclusive group except the current one
            for J := low(Lines_) to high(Lines_) do
            begin
              if (Lines_[J].Excl <> -1)
                and (Lines_[I].Excl <> -1)
                and (Lines_[J].Excl = Lines_[I].Excl)
                and (J <> I)
                then Clear_Line(J);
            end;

            Clear_Exclusive_Groups(Lines_[I].Group);
            Follow_Lines;
            Follow_Not_Lines;

            if DoCalculate then Calculate1Click(Sender);
          end;

        end;
      end;

    end;

    if (not Found) and (length(Lines_Register) > 0) then // not found in the normal config lines, check the register lines
    begin
      if Length(Lines_Register) > 0 then
      begin
        for I := low(Lines_Register) to high(Lines_Register) do
        begin
          if Within(X, Y, Lines_Register[I].X1, Lines_Register[I].Y1, Lines_Register[I].X2, Lines_Register[I].Y2)
            then
          begin
            begin
              Red_Line_Register(I);

              for K := 0 to length(RegisterValues) - 1 do
              begin
                if RegisterValues[K].RegName = Lines_Register[I].Name then
                begin
                  RegisterValues[K].Value := Lines_Register[I].Value; // remember (last) selected value
                  RegisterValues[K].Comments := Lines_Register[I].Comments; // and its comments
                  RegisterValues[K].Calc := Lines_Register[I].Calc; // remember selected formulavalue
                  RegisterValues[K].Changed := true;
                end;
              end;

          // make lines red in the inclusive group
              for J := 0 to high(Lines_Register) do
              begin
                if (Lines_Register[J].Incl <> -1)
                  and (Lines_Register[I].Incl <> -1)
                  and (Lines_Register[J].Incl = Lines_Register[I].Incl)
                  then Red_Line_Register(J);
              end;

            // clear lines in the exclusive group except the current one
              for J := 0 to high(Lines_Register) do
              begin
                if (Lines_Register[J].Excl <> -1)
                  and (Lines_Register[I].Excl <> -1)
                  and (Lines_Register[J].Excl = Lines_Register[I].Excl)
                  and (J <> I)
                  then Clear_Line_Register(J);
              end;

              Clear_Exclusive_Groups(Lines_Register[I].Group);
              Follow_Lines;
              Follow_Not_Lines;

              if DoCalculate then Calculate1Click(Sender);
            end;

          end;
        end;

      end;

    end;
  end else
  begin
    if Button = mBMiddle
      then
    begin
      X1 := X;
      Y1 := Y;
    end else
      if Button = mbRight then
    begin
      X2 := X;
      Y2 := Y;
      TmpStr := intToStr(X1) + ', ' + intToStr(Y1) + ', ' + intToStr(X2) + ', ' + intToStr(Y2) + ', ';
      Clipboard.AsText := TmpStr;
    end;
  end
end;

procedure TForm1.Get_Config_Bits(ProcName: string);
var
  N, P, P2: longint;
  I: longint;
  TmpS: ansistring;
  MlkFile: TStringList;
  MaxLen, L: word;
begin

  ChDir(AppExeFileDirectory(true)); // make sure to start in the application's directory (for TSimpleIniFile)

  if CheckWin32Version(6)
    then
    for I := 0 to 8 do ActualDefPaths[I] := Win7DefPaths[I]
  else
    for I := 0 to 8 do ActualDefPaths[I] := XpDefPaths[I];

  // Check Inifile Contents

  IniFile := TSimpleIniFile.Create();
  // update the inifile with the default paths if they are not present, this will only happen once
  IniFile := TSimpleIniFile.Create();
  if not IniFile.ValueExists('PIC', 'mP') then IniFile.WriteString('PIC', 'mP', ActualDefPaths[0]);
  if not IniFile.ValueExists('dsPIC', 'mP') then IniFile.WriteString('dsPIC', 'mP', ActualDefPaths[1]);
  if not IniFile.ValueExists('PIC32', 'mP') then IniFile.WriteString('PIC32', 'mP', ActualDefPaths[2]);
  if not IniFile.ValueExists('PIC', 'mB') then IniFile.WriteString('PIC', 'mB', ActualDefPaths[3]);
  if not IniFile.ValueExists('dsPIC', 'mB') then IniFile.WriteString('dsPIC', 'mB', ActualDefPaths[4]);
  if not IniFile.ValueExists('PIC32', 'mB') then IniFile.WriteString('PIC32', 'mB', ActualDefPaths[5]);
  if not IniFile.ValueExists('PIC', 'mC') then IniFile.WriteString('PIC', 'mC', ActualDefPaths[6]);
  if not IniFile.ValueExists('dsPIC', 'mC') then IniFile.WriteString('dsPIC', 'mC', ActualDefPaths[7]);
  if not IniFile.ValueExists('PIC32', 'mC') then IniFile.WriteString('PIC32', 'mC', ActualDefPaths[8]);
  IniFile.UpdateFile;
  IniFile.Free;

  // Read back the values from the inifile (values corrected by a user setup action)
  IniFile := TSimpleIniFile.Create();
  ActualDefPaths[0] := IniFile.ReadString('PIC', 'mP', '');
  ActualDefPaths[1] := IniFile.ReadString('dsPIC', 'mP', '');
  ActualDefPaths[2] := IniFile.ReadString('PIC32', 'mP', '');
  ActualDefPaths[3] := IniFile.ReadString('PIC', 'mB', '');
  ActualDefPaths[4] := IniFile.ReadString('dsPIC', 'mB', '');
  ActualDefPaths[5] := IniFile.ReadString('PIC32', 'mB', '');
  ActualDefPaths[6] := IniFile.ReadString('PIC', 'mC', '');
  ActualDefPaths[7] := IniFile.ReadString('dsPIC', 'mC', '');
  ActualDefPaths[8] := IniFile.ReadString('PIC32', 'mC', '');
  IniFile.Free;

  // find the Defsdirectory
  Error := true;
  for N := 0 to high(ActualDefpaths) do
  begin
    if FileExists(ActualDefPaths[N] + '\' + ProcName + '.mlk') then
    begin
      DefsDirectory := ActualDefPaths[N];
      Error := false;
      break;
    end;
  end;

  if Error then
  begin
    ShowMessage('Defs directory not found');
    exit;
  end;

  try
    ChDir(DefsDirectory);
  except
    on Exception do
    begin
      Error := true;
      Showmessage('Directory "' + DefsDirectory + '" does not exist,' + #13 + #10 + 'Please edit the "Oscillator_Configuration.ini" file to correct it.');
      exit;
    end;
  end;

  MlkFile := TStringList.Create;
  try
    MlkFile.LoadFromFile(ProcName + '.mlk');
  except
    on Exception do
    begin
      Error := true;
      Showmessage('MLK File "' + ProcName + '.mlk' + '" not Found?');
      exit;
    end;
  end;

  SetLength(ConfigBits, 0);
  LoadingState := Waiting;

  if (MlkFile.Count > 0) then
  begin
    MaxLen := 0;

    I := 0;
    while (I < MlkFile.Count) and (LoadingState <> CfgDone) do
    begin
      TmpS := MlkFile[I];

      if Keyword('cfg', TmpS) then
        LoadingState := CfgFound;

      if Keyword('/cfg', TmpS) then
        LoadingState := CfgDone;

      if (LoadingState <> Waiting) and (LoadingState <> CfgDone) then
      begin

        if KeywordX('cfgbits', TmpS) then
        begin
          LoadingState := CfgbitsX;
          CfgBitsIndex := length(ConfigBits);
          SetLength(ConfigBits, CfgBitsIndex + 1);
          ConfigBits[CfgBitsIndex].SKey := '';
          ConfigBits[CfgBitsIndex].WAddr := 0;
          SetLength(ConfigBits[CfgBitsIndex].Fields, 0);
        end;

        if KeywordX('field', TmpS) then
        begin
          LoadingState := FieldX;
          FieldIndex := length(ConfigBits[CfgBitsIndex].Fields);
          SetLength(ConfigBits[CfgBitsIndex].Fields, FieldIndex + 1);
          ConfigBits[CfgBitsIndex].Fields[FieldIndex].SKey := '';
          ConfigBits[CfgBitsIndex].Fields[FieldIndex].SDesc := '';
          ConfigBits[CfgBitsIndex].Fields[FieldIndex].WMask := 0;
          SetLength(ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings, 0);
        end;

        if KeywordX('setting', TmpS) then
        begin
          LoadingState := SettingX;
          SettingsIndex := length(ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings);
          SetLength(ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings, SettingsIndex + 1);
          ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings[SettingsIndex].WReq := 0;
          ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings[SettingsIndex].WValue := 0;
          ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings[SettingsIndex].SDesc := '';
        end;

        if Keyword('skey', TmpS) then
        begin
          RemoveJunk(TmpS);
          case LoadingState of
            CfgbitsX: ConfigBits[CfgBitsIndex].SKey := TmpS;
            FieldX:
              begin
                ConfigBits[CfgBitsIndex].Fields[FieldIndex].SKey := TmpS;
                L := length(ConfigBits[CfgBitsIndex].Fields[FieldIndex].SDesc) +
                  length(ConfigBits[CfgBitsIndex].Fields[FieldIndex].SKey);
                if L > MaxLen then MaxLen := L;
              end;
          end;
        end;

        if Keyword('waddr', TmpS) then
        begin
          RemoveJunk(TmpS);
          case LoadingState of
            CfgbitsX: ConfigBits[CfgBitsIndex].WAddr := StrToInt64(TmpS);
          end;
        end;

        if Keyword('wmask', TmpS) then
        begin
          RemoveJunk(TmpS);
          case LoadingState of
            FieldX: ConfigBits[CfgBitsIndex].Fields[FieldIndex].WMask := StrToInt64(TmpS);
          end;
        end;

        if Keyword('wreq', TmpS) then
        begin
          RemoveJunk(TmpS);
          case LoadingState of
            SettingX: ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings[SettingsIndex].WReq := StrToInt64(TmpS);
          end;
        end;

        if Keyword('wValue', TmpS) then
        begin
          RemoveJunk(TmpS);
          case LoadingState of
            SettingX: ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings[SettingsIndex].WValue := StrToInt64(TmpS);
          end;
        end;

        if Keyword('sdesc', TmpS) then
        begin
          RemoveJunk(TmpS);

          P := pos('(', TmpS);
          P2 := pos(')', TmpS);
          if (P > 0) and (P2 = 0) then delete(TmpS, P, 255);
          TmpS := trim(TmpS);

          case LoadingState of
            FieldX:
              begin
                ConfigBits[CfgBitsIndex].Fields[FieldIndex].SDesc := TmpS;
                L := length(ConfigBits[CfgBitsIndex].Fields[FieldIndex].SDesc) +
                  length(ConfigBits[CfgBitsIndex].Fields[FieldIndex].SKey);
                if L > MaxLen then MaxLen := L;
              end;
            SettingX:
              begin
                ConfigBits[CfgBitsIndex].Fields[FieldIndex].Settings[SettingsIndex].SDesc := TmpS;
              end;
          end;
        end;

      end;

      inc(I);
    end;
  end;

  MlkFile.Free;
end;

procedure TForm1.Select_First_Lines;
var TmpStr: TstringList;
  I: word;
begin
  DoCalculate := false;

  TmpStr := TStringList.Create;
  if length(Lines_) > 0 then
  begin
    for I := 0 to length(Lines_) - 1 do
    begin
      if TmpStr.IndexOf(Lines_[I].Name) = -1 then
      begin
        TmpStr.Add(Lines_[I].Name);
        Image1MouseDown(Image1, mbLeft, [], Lines_[I].X1, Lines_[I].Y1);
      end;
    end;
  end;

  TmpStr.Clear;
  if length(Lines_Register) > 0 then
  begin
    for I := 0 to length(Lines_Register) - 1 do
    begin
      if  TmpStr.IndexOf(Lines_Register[I].Name) = -1  then
      begin
        TmpStr.Add(Lines_Register[I].Name);
        Image1MouseDown(Image1, mbLeft, [], Lines_Register[I].X1, Lines_Register[I].Y1);
      end;
    end;
  end;
  TmpStr.Free;
  
  DoCalculate := true;
end;

procedure TForm1.Select_Processor(ProcName: string);
var I, J, K: word;
  TmpS: string;
begin

  for i := 0 to LAST_EDIT do
  begin
    Edits[i].Visible := false;
    Edits[I].text := '';
  end;

  ProcessorName := trim(ProcName);
  Get_Config_Bits(ProcessorName); // use original processorname here

  if Error then exit; // no config bits

  ChDir(AppExeFileDirectory(true)); // make sure to start in the application's directory (for TSimpleIniFile)

  // use the defined processorname here
  TmpS := '';
  if (length(Pic_Types) > 0) then
  begin
    for I := low(Pic_Types) to High(PIC_Types) do
    begin
      if Pic_Types[I].Wanted = ProcName then
      begin
        TmpS := Pic_Types[I].ToUse;
        break;
      end;
    end;
  end;

  if (TmpS > '') then // the "ToUse" processorname
  begin

    Image1.Picture.LoadFromFile('Oscillator_' + TmpS + '.bmp');
    Read_Lines(TmpS);

    Reset1.Visible := true;
    Code1.Visible := true;
    Help1.Visible := true;

    Clear_Lines; // unselect all lines
    Clear_Lines_Register; // unselect all lines

    // clear all output
    TmpS := '';
    Label1.Caption := TmpS;
    Label2.Caption := TmpS;
    Label3.Caption := TmpS;
    Label4.Caption := TmpS;
    Label5.Caption := TmpS;
    Label6.Caption := TmpS;
    Label7.Caption := TmpS;
    Label8.Caption := TmpS;
    Label9.Caption := TmpS;
    Label10.Caption := TmpS;
    Label11.Caption := TmpS;
    Label12.Caption := TmpS;
    Label13.Caption := TmpS;
    Label14.Caption := TmpS;
    Label15.Caption := TmpS;
    Label16.Caption := TmpS;
    Label17.Caption := TmpS;
    Label18.Caption := TmpS;
    Label19.Caption := TmpS;
    Label20.Caption := TmpS;
    Label21.Caption := TmpS;
    Label22.Caption := TmpS;
    Label23.Caption := TmpS;
    Label24.Caption := TmpS;
    Label25.Caption := TmpS;
    Label26.Caption := TmpS;
    Label27.Caption := TmpS;
    Label28.Caption := TmpS;
    Label29.Caption := TmpS;
    Label30.Caption := TmpS;
    Label31.Caption := TmpS;
    Label32.Caption := TmpS;
    Label33.Caption := TmpS;
    Label34.Caption := TmpS;
    Label35.Caption := TmpS;
    Label36.Caption := TmpS;
    Label37.Caption := TmpS;
    Label38.Caption := TmpS;
    Label39.Caption := TmpS;

    if FieldNames_.Count > 0 then
    begin
      for I := 0 to FieldNames_.Count - 1 do
      begin
        for J := low(ConfigBits) to high(ConfigBits) do
          for K := low(ConfigBits[J].Fields) to high(ConfigBits[J].Fields) do
            if ConfigBits[J].Fields[K].SKey = FieldNames_[I] then
            begin
              TmpS := ConfigBits[J].Fields[K].SDesc;

              case I of
                0: Label1.Caption := TmpS;
                1: Label3.Caption := TmpS;
                2: Label5.Caption := TmpS;
                3: Label7.Caption := TmpS;
                4: Label9.Caption := TmpS;
                5: Label11.Caption := TmpS;
                6: Label13.Caption := TmpS;
                7: Label15.Caption := TmpS;
                8: Label17.Caption := TmpS;
                9: Label19.Caption := TmpS;
                10: Label21.Caption := TmpS;
                11: Label23.Caption := TmpS;
                12: Label25.Caption := TmpS;
                13: Label27.Caption := TmpS;
                14: Label29.Caption := TmpS;
                15: Label31.Caption := TmpS;
                16: Label33.Caption := TmpS;
                17: Label35.Caption := TmpS;
                18: Label37.Caption := TmpS;
                19: Label39.Caption := TmpS;
              end;
            end;
      end;
    end;
    Select_First_Lines; // select the first line in each group with the same name
    Calculate1Click(nil);
  end;
end;

procedure TForm1.Load_PIcs;
var F: textfile;
  P: word;
  TmpStr: string;
  L, R: string;
  len_: word;
begin
  ChDir(AppExeFileDirectory(true)); // make sure to start in the application's directory (for TSimpleIniFile)

  SetLength(Pic_Types, 0);
  ListBox1.Items.Clear;

  if not FileExists('Oscillator_Configuration_PICs.txt') then
  begin
    ShowMessage('File "Oscillator_Configuration_PICs.txt" not found');
    error := true;
    exit;
  end;

  AssignFile(F, 'Oscillator_Configuration_PICs.txt');
  reset(F);
  while not Eof(F) do
  begin
    readln(F, TmpStr);
    TmpStr := Trim(TmpStr);

    P := pos('//', TmpStr);
    if P > 0 then
      TmpStr := copy(TmpStr, 1, P - 1);
    TmpStr := trim(TmpStr);

    if (TmpStr > '') then
    begin

      SplitString(TmpStr, '=', L, R);
      L := trim(L);
      R := trim(R);

      if L <> '-' then
      begin
        Len_ := length(Pic_Types);
        setlength(Pic_Types, Len_ + 1);
        Pic_Types[Len_].Wanted := L;
        Pic_Types[Len_].ToUse := R;
      end;

      ListBox1.Items.Add(L);
    end;
  end;
  Closefile(F);

  if length(Pic_Types) = 0 then
  begin
    error := true;
    exit;
  end;

end;

procedure TForm1.FormShow(Sender: TObject);
var i: word;
begin
  DecimalSeparator := '.';
  ThousandSeparator	:= #0;
  
  FieldNames_ := TStringList.Create;
  RegisterNames_ := TStringList.Create;
  Eval := TSimpleEval.Create;

  for i := 0 to LAST_EDIT do
  begin
    Edits[i] := TEdit.Create(form1);
    with Edits[i] do
    begin
      width := 50;
      top := 50;
      left := 50;
      text := '';
      parent := form1;
      visible := false;
      

    // more properties...
    end;
  end;

  Error := false;
  Load_Pics;
end;

procedure TForm1.Code1Click(Sender: TObject);
var I, J: word;
  MaskStr, UpMaskStr, LoMaskStr: string;
  Mask, UpMask, LoMask: Dword;
  TmpStr, Line_: string;
begin

  Form2.Memo1.Clear;
  if length(RegisterValues) > 0 then
  begin
    for I := low(RegisterValues) to high(RegisterValues) do
    begin
      if RegisterValues[I].Changed then
      begin

        MaskStr := Copy(RegisterValues[I].RegName, pos('<', RegisterValues[I].RegName) + 1, 255);
        Delete(MaskStr, length(MaskStr), 1);

        TmpStr := copy(RegisterValues[I].RegName, 1, pos('<', RegisterValues[I].RegName) - 1);

        UpmaskStr := MaskStr;
        if pos(':', MaskStr) > 0
          then SplitString(MaskStr, ':', UpMaskStr, LoMaskStr)
        else LoMaskStr := UpmaskStr;

        UpMask := StrToInt(UpMaskStr);
        LoMask := StrToInt(LoMaskStr);

        Mask := 0;
        for J := LoMask to UpMask do Mask := Mask + (1 shl J);

        Line_ := TmpStr + ' := (' + TmpStr + ' and (not ' +
          intTostr(Mask) + '))';

        if RegisterValues[I].Value > 0
          then Line_ := Line_ + ' or ' + inttostr((RegisterValues[I].Value shl LoMask));

        Line_ := Line_ + '; ' + RegisterValues[I].Comments;

        Form2.Memo1.Lines.add(Line_);
      end;
    end;
  end;
  Form2.Show;

end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if (ListBox1.ItemIndex >= 0) and (trim(ListBox1.Items[ListBox1.ItemIndex]) > '') then
  begin
    try
      Select_processor(ListBox1.Items[ListBox1.ItemIndex]);
    finally
      Listbox1.Visible := false;
    end;
  end;
end;

procedure TForm1.PIC1Click(Sender: TObject);
begin
  ListBox1.BringToFront;
  ListBox1.Visible := true;
  ListBox1.SetFocus;
end;

procedure TForm1.Help1Click(Sender: TObject);
begin
  Form3.Show;
end;

procedure TForm1.ClearAll1Click(Sender: TObject);
var TmpS: string;
  K: word;
begin
  Clear_lines;
  Clear_Lines_Register;

  // clear all output
  TmpS := '';

  Label2.Caption := TmpS;
  Label4.Caption := TmpS;
  Label6.Caption := TmpS;
  Label8.Caption := TmpS;
  Label10.Caption := TmpS;
  Label12.Caption := TmpS;
  Label14.Caption := TmpS;
  Label16.Caption := TmpS;
  Label18.Caption := TmpS;
  Label20.Caption := TmpS;
  Label22.Caption := TmpS;
  Label24.Caption := TmpS;
  Label26.Caption := TmpS;
  Label28.Caption := TmpS;
  Label30.Caption := TmpS;
  Label32.Caption := TmpS;
  Label34.Caption := TmpS;
  Label36.Caption := TmpS;
  Label38.Caption := TmpS;

  if length(RegisterValues) > 0 then
  begin
    for K := 0 to length(RegisterValues) - 1 do RegisterValues[K].Changed := false;
  end;

  Follow_lines;

end;

procedure TForm1.ClearConfigbits1Click(Sender: TObject);
var TmpS: string;
begin
  Clear_Lines;

    // clear all output
  TmpS := '';

  Label2.Caption := TmpS;
  Label4.Caption := TmpS;
  Label6.Caption := TmpS;
  Label8.Caption := TmpS;
  Label10.Caption := TmpS;
  Label12.Caption := TmpS;
  Label14.Caption := TmpS;
  Label16.Caption := TmpS;
  Label18.Caption := TmpS;
  Label20.Caption := TmpS;
  Label22.Caption := TmpS;
  Label24.Caption := TmpS;
  Label26.Caption := TmpS;
  Label28.Caption := TmpS;
  Label30.Caption := TmpS;
  Label32.Caption := TmpS;
  Label34.Caption := TmpS;
  Label36.Caption := TmpS;
  Label38.Caption := TmpS;

  Follow_lines;
  Follow_Not_Lines;
end;

procedure TForm1.ClearRegisterSettings1Click(Sender: TObject);
var K: word;
begin
  Clear_Lines_Register;
  Follow_lines;
  Follow_Not_Lines;

  if length(RegisterValues) > 0 then
  begin
    for K := 0 to length(RegisterValues) - 1 do RegisterValues[K].Changed := false;
  end;
end;

procedure TForm1.ReloadAll1Click(Sender: TObject);
begin
  if ProcessorName > '' then Select_Processor(ProcessorName);
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i: word;
begin
  FieldNames_.Free;
  RegisterNames_.Free;
  Eval.Free;

  for i := 0 to LAST_EDIT do Edits[i].Free;
end;

function Normalise_Formula(Formula: string): string;
var TmpStr, TmpS: string;
  p1, I, J: word;
begin
  TmpStr := Formula;

  for I := 1 to length(TmpStr) - 2 do
  begin
    if TmpStr[I] = '<' then
    begin
      p1 := I;
      while (TmpStr[p1] <> '>') and (p1 < length(TmpStr)) do inc(p1);
      if (p1 <= length(TmpStr)) then
      begin
        TmpS := copy(TmpStr, I + 1, P1 - I - 1);
        TmpS := StringReplace(TmpS, ':', '', []);
        if Isnumber(TmpS) then
        begin
          TmpStr[I] := '_';
          TmpStr[p1] := '_';
          for J := I to p1 do if TmpStr[J] = ':' then
            begin
              TmpStr[J] := '_';
              break;
            end;
        end;
      end;
    end;
  end;

  Result := TmpStr;
end;

procedure TForm1.Calculate1Click(Sender: TObject);
var I, tmp: word;
  Dest, TmpS, FloatS: string;
  R: real;
begin

  for I := 0 to LAST_EDIT do
  begin
    TmpS := 'E' + trim(inttostr(I));
    if IsNumber(NumericalString(Edits[I].Text)) then
    begin
      R := StrToFloat(NumericalString(Edits[I].Text));
      Eval.SetVar('E' + trim(inttostr(I)), R);
    end
    else Eval.SetVar('E' + trim(inttostr(I)), 1.0);
  end;

  for I := 0 to length(CalcValues) - 1 do
  begin
    Eval.SetVar(CalcValues[I].FieldName, CalcValues[I].Calc);
  end;

  for I := 0 to length(RegisterValues) - 1 do
  begin
    TmpS := RegisterValues[I].RegName;
    TmpS := StringReplace(TmpS, '<', '_', [rfReplaceAll]);
    TmpS := StringReplace(TmpS, '>', '_', [rfReplaceAll]);
    TmpS := StringReplace(TmpS, ':', '_', [rfReplaceAll]);
    Eval.SetVar(TmpS, RegisterValues[I].Calc);
  end;

  if length(Formulas) > 0 then
  begin
    for I := 0 to (length(Formulas) - 1) do
    begin
      if Formulas[I].Formula > '' then
      begin
        Dest := Formulas[I].Destination;
        Tmp := strtoint(copy(Dest, 2, 255));
        TmpS := Formulas[I].Formula;
        TmpS := Normalise_Formula(TmpS);
        Eval.Formula := TmpS;
        FloatS := FloatToStrF(Eval.Result, ffFixed, 10, 3);
        while FloatS[length(FloatS)] = '0' do delete(FloatS, length(FloatS), 1);
        if FloatS[length(FloatS)] = '.' then delete(FloatS, length(FloatS), 1);
        Edits[I].Text := FloatS + ' Mhz';
        Eval.SetVar('E' + trim(inttostr(Tmp)), StrToFloat(NumericalString(Edits[I].Text)));
      end;
    end;
  end;
end;

procedure TForm1.EditKeypress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Calculate1Click(Sender);
  end;
end;

end.
